#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>

#define TMPNAME "/tmp/jmayerXXXXXX"	/* XXXXXX am Ende wg. mktemp! */
#define BUFSIZE 128

int main() {
    char tmp[BUFSIZE];
    int fd;

    /* temp. Dateiname mit mktemp() erzeugen;
     * "XXXXXX" muss am Ende des Templates stehen und wird ersetzt */
    strcpy(tmp, TMPNAME);
    if (!mktemp(tmp))	/* Parameter von mktemp() wird veraendert! */
	perror("mktemp"), exit(1);

    printf("Temp-Name: %s\n", tmp);
    
    /* temporaere Datei oeffnen -- aber nur, wenn sie noch nicht existiert */
    if ((fd = open(tmp, O_RDWR | O_CREAT | O_TRUNC | O_EXCL, 0600)) < 0)
	perror("open"), exit(2);
    
    /* danach Dateinamen loeschen -- I/O-Verb. zur Datei immer noch via fd! */
    unlink(tmp);
    
    /* Arbeiten mit der temp. Datei */
    
    /* nun aber wirklich die Inode und den Plattenplatz freigeben */
    close(fd);
    
    return 0;
}

