#include <stdio.h>
#include <unistd.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>

#define TMPNAME "/tmp/jmayerXXXXXX"	/* XXXXXX am Ende wg. mktemp! */
#define BUFSIZE 128

int main() {
    char tmp[BUFSIZE];
    int fd;

    /* temp. Dateiname mit mktemp() erzeugen;
     * "XXXXXX" muss am Ende des Templates stehen und wird ersetzt */
    strcpy(tmp, TMPNAME);
    if( (fd = mkstemp(tmp)) < 0)  /* Parameter von mktemp() wird veraendert! */
	perror("mkstemp"), exit(1);
    
    /* danach Dateinamen loeschen -- I/O-Verb. zur Datei immer noch via fd! */
    unlink(tmp);
    
    /* Arbeiten mit der temp. Datei */
    
    /* nun aber wirklich die Inode und den Plattenplatz freigeben */
    close(fd);
    
    return 0;
}

